my %ctracker_track;
my %ctracker_meetmemembers;
my %ctracker_durations;

$AMI_Event_Handler{'conferencetrack'}{'CONFBRIDGESTART'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $room    = ${$event}{Conference};
    my $now    = time;
    my $roomid = $room."-".$now;

    $ctracker_track{$room}=$roomid;

    open(my $fh, '>>', '/var/log/asterisk/conference_log');
    print $fh "$now|$roomid|$room|START|\n"; 
    close $fh;
    return @allreturn;
 
};

$AMI_Event_Handler{'conferencetrack'}{'CONFBRIDGEEND'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $room    = ${$event}{Conference};

    if(!defined($ctracker_track{$room})) {
        return @allreturn;
    }

    my $now = time();
    my $roomid = $ctracker_track{$room};

    open(my $fh, '>>', '/var/log/asterisk/conference_log');
    print $fh "$now|$roomid|$room|END|\n";
    delete $ctracker_track{$room};
    delete $ctracker_durations{$room};
    close $fh;
    return @allreturn;
};

$AMI_Event_Handler{'conferencetrack'}{'MEETMEJOIN'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $uniqueid    = ${$event}{Uniqueid};
    my $clidnum     = ${$event}{CallerIDnum};
    my $clidname    = ${$event}{CallerIDname};
    my $usernum     = ${$event}{Usernum};
    my $room        = ${$event}{Meetme};
    my $conference  = ${$event}{Conference};

    if($room ne "" and $conference eq "") {
        # This is a meetme event

        my $now    = time;
        my $roomid = $room."-".$now;
    
        $ctracker_durations{$room}{$uniqueid} = time;

        open(my $fh, '>>', '/var/log/asterisk/conference_log');

        if($usernum == 1) {
            # Conference just started
            $ctracker_track{$room}=$roomid;

            print $fh "$now|$roomid|$room|START|\n"; 
            print $fh "$now|$roomid|$room|JOIN|1|$clidnum|$clidname\n";
            push @{$ctracker_meetmemembers{$roomid}}, $uniqueid;  


        } else {
            # Another member on existing conference
            if(defined($ctracker_track{$room})) {
                $roomid = $ctracker_track{$room};
                print $fh "$now|$roomid|$room|JOIN|$usernum|$clidnum|$clidname\n";
                push @{$ctracker_meetmemembers{$roomid}}, $uniqueid;  
            } 
        }
        my $cuantos = @{$ctracker_meetmemembers{$roomid}};
        print $fh "$now|$roomid|$room|PARTICIPANTS|$cuantos\n";
        close $fh;

    } else {
        # This is a confbridge event
        my $now    = time;
        my $roomid = $conference."-".$now;

        if(defined($ctracker_track{$conference})) {
            $roomid = $ctracker_track{$conference};
        }

        my $cuantos = 0;
        if(defined($ctracker_meetmemembers{$roomid})) {
            $cuantos = @{$ctracker_meetmemembers{$roomid}};
        }
        $cuantos++;

        $ctracker_durations{$conference}{$uniqueid} = time;

        print Dumper \%ctracker_durations;

        open(my $fh, '>>', '/var/log/asterisk/conference_log');
        print $fh "$now|$roomid|$conference|JOIN|$cuantos|$clidnum|$clidname\n";
        push @{$ctracker_meetmemembers{$roomid}}, $uniqueid;  
        print $fh "$now|$roomid|$conference|PARTICIPANTS|$cuantos\n";
        close $fh;

    }
    return @allreturn;
};

$AMI_Event_Handler{'conferencetrack'}{'MEETMELEAVE'} = sub {
    my $event = shift;
    my @allreturn;
    my @keys =  keys %$event;

    my $uniqueid    = ${$event}{Uniqueid};
    my $clidnum     = defined(${$event}{CallerIDNum})?${$event}{CallerIDNum}:${$event}{CallerIDnum};
    my $clidname    = defined(${$event}{CallerIDName})?${$event}{CallerIDName}:${$event}{CallerIDname};
    my $usernum     = ${$event}{Usernum};
    my $room        = ${$event}{Meetme};
    my $conference  = ${$event}{Conference};

    my $now = time();

    if($room ne "" and $conference eq "") {

        if(!defined($ctracker_track{$room})) {
            return @allreturn;
        }

        my $roomid = $ctracker_track{$room};

        my $join_time = $ctracker_durations{$room}{$uniqueid};

        $duration = $now - $join_time;
 
        my @quedan;
        foreach my $itm (@{$ctracker_meetmemembers{$roomid}}) {
           if($itm ne $uniqueid) {
                push @quedan, $itm;
           }
        }
        my $cuantos = @quedan;
        @{$ctracker_meetmemembers{$roomid}} = @quedan;

        open(my $fh, '>>', '/var/log/asterisk/conference_log');
        print $fh "$now|$roomid|$room|LEAVE|$duration|$clidnum|$clidname\n";

        if($cuantos == 0) {
            print $fh "$now|$roomid|$room|END|\n";
            delete $ctracker_track{$room};
            delete $ctracker_durations{$room};
            delete $ctracker_meetmemembers{$roomid};
        } 
        close $fh;
        return @allreturn;
    } else {

        # its confbridge

        if(!defined($ctracker_track{$conference})) {
            return @allreturn;
        }

        print Dumper \%ctracker_durations;

        my $join_time = $ctracker_durations{$conference}{$uniqueid};

        $duration = $now - $join_time;

        my $roomid = $ctracker_track{$conference};

        my @quedan;
        foreach my $itm (@{$ctracker_meetmemembers{$roomid}}) {
           if($itm ne $uniqueid) {
                push @quedan, $itm;
           }
        }
        my $cuantos = @quedan;
        @{$ctracker_meetmemembers{$roomid}} = @quedan;

        open(my $fh, '>>', '/var/log/asterisk/conference_log');
        print $fh "$now|$roomid|$conference|LEAVE|$duration|$clidnum|$clidname\n";
        close $fh;
        return @allreturn;

    }

};

